#!/usr/bin/perl
# 
# ezguestd.$cgi - EZ Guestbook Generator - by Manny Juan <manny@jps.net> 1/23/99
# http://www.mannyjuan.com/userpages/
#
# v1.40 9/15/2001 added capability to accept user's background and/or logo
# v1.30 3/1/2000 this function was suggested by Andrew Burk (andrew@cobra.net) and the 
# code was derived from his original enhancements to ezguest script
#
#####################################################################################
$SIG{__DIE__} = \&Error_Msg;

sub Error_Msg {
    $msg = "@_";
    print "\ncontent-type: text/html\n\n";
    print "The following error occurred : $msg\n";
    exit;
}

# Get the input
read(STDIN, $input, $ENV{'CONTENT_LENGTH'});

    # split the input
    @pairs = split(/&/, $input);

    # split the name/value pairs
    foreach $pair (@pairs) {

    ($name, $value) = split(/=/, $pair);

    $name =~ tr/+/ /;
    $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/<([^>]|\n)*>//g;

    $FORM{$name} = $value;
    }
$userdir = $FORM{'userdir'};
$gbparms=$FORM{'gbparms'};
($maxdays,$maxitems,$recipient,$separator,$mail,$linkmail,$remote_mail,
$line_breaks,$retlink,$usemybkgd,$mybkgdurl,$usemylogo,$mylogourl) = split('~',$gbparms);

$colorset=$FORM{'colorset'};
if ($colorset eq "") {$colorset='FFFFFF~333333~006699~999900';}
($bkgdc, $textc, $linkc, $vlinkc) = split('~', $colorset);
######################################################################################
# set variables HERE

$win95=0;
$cgi='pl';
# Set this to your base HTML directory. This is a PATH not a URL
# $base_dir = "../webpages/$userdir";
$base_dir = "/home/manny/www/$userdir";

# $cgiurl = "/cgi-bin";
$cgiurl = "/cgi-bin";

# This is your URL of where the new HTML pages will be kept - keep the trailing slash
# $baseurl = "/$userdir/";
$baseurl = "http://www.mannyjuan.com/$userdir/";

# This is a URL and dir for the images sub directory in the userpages directory.
# Create the images directory in the userpages directory. This is where
# you will upload your background images
# $imageurl = "/$userdir";
$imageurl = "http://www.mannyjuan.com/$userdir/";

# This is the path for user pages. You don't really need to change this
# Just make sure to create a directory: userpages and chmod it 777
$page_dir = "$base_dir/";

# This is the index of all generated pages
# This file should be chmod to 777 and placed in the userpages directory
$indexpage = "$base_dir/index.html";

#Site title

$title="EZ Guestbook Mall";

# self explanatory variables for your site logo
$logo = "$imageurl/mjmall.jpg";
$logoalt = "Cyber Mall";

# Location of the sendmail program
$sendmail = '/usr/sbin/sendmail';

# Your e-mail address here
$myemail = 'manny@jps.net';

# That's it.

# DO NOT CHANGE ANYTHING BELOW THIS LINE
######################################################################################

# Lets do some translating first
$pagename = $FORM{'pagename'};
$gbentry = $FORM{'gbentry'};
$action = $FORM{'action'};


$pagename =~ s/ /_/g;

if ($action eq 'delgbitm') {
    &build_page;
    exit;
    }
if ($action eq 'delentry') {
    print "content-type: text/html\n\n";
    &update_page;
    exit;
    }
sub build_page {
    print "content-type: text/html\n\n";
    # Suck the user page and reformat with delete buttons
    open(FILE, "$base_dir/$pagename.html") || die "I can't open that file $base_dir/$pagename.html\n";
    if($win95==0){flock (FILE, 1) or die "can't lock index file\n";}
    @lines = <FILE>;
    close(FILE);
    $sizelines = @lines;
    $temp=1;
    for ($a = 0; $a <= $sizelines; $a++) {

        $_ = $lines[$a];
        if ($temp==1) {
        if (/<!--begin-->/) {
            print "<!--begin-->\n";
            $temp=2;  
            $gbn=0;
            }
        else {
            print $_;
            }
        }
        elsif ($temp==2) {
            if (/^\d+\/\d+\/\d+/) { 
                if ($gbn>0) {print "</form>\n";}
                $gbn++;
                print "<form action=\"$cgiurl/ezguestd.$cgi\" method=POST><input type=submit value=delete><br>\n";
                print "<input type=hidden name=userdir value=$userdir>";
                print "<input type=hidden name=pagename value=$pagename>";
                print "<input type=hidden name=action value=\"delentry\">";
                print "<input type=hidden name=gbentry value=$gbn>";
                print "<input type=hidden name=\"gbparms\" value=\"$gbparms\">\n";
                print "<input type=hidden name=\"colorset\" value=\"$colorset\">\n";
                print "\n";
                print $_;
                $temp=3;
            }
            else {
                print $_;
            }
        }
        elsif ($temp==3) {
            if (/<!--end-->/) {
                if ($gbn>0) {print "</form>\n";}
                print "<!--end-->\n";
                $temp=4;
            }
            else {
                print $_;
                $temp=2;
            }
        }
        else {
            print $_;
        }
   }
}
sub update_page {
   # Suck the user page and reformat with delete buttons
    open(FILE, "$base_dir/$pagename.html") || die "I can't open that file $base_dir/$pagename.html\n";
    if($win95==0){flock (FILE, 1) or die "can't lock $base_dir/$pagename.html\n";}
    @lines = <FILE>;
    close(FILE);
    $sizelines = @lines;

    # open for output
    @delitem=();
    open(FILE, ">$base_dir/$pagename.html") || die "I can't open that file $base_dir/$pagename.html for output\n";
    if($win95==0){flock (FILE, 2) or die "can't lock $base_dir/$pagename.html for output\n";}
    $temp=1;
    for ($a = 0; $a <= $sizelines; $a++) {

        $_ = $lines[$a];
        if ($temp==1) {
        if (/<!--begin-->/) {
            print FILE "<!--begin-->\n";
            $temp=2;  
            $gbn=0;
            }
        else {
            print FILE $_;
            }
        }
        elsif ($temp==2) {
            if (/^\d+\/\d+\/\d+/) { 
                $gbn++;
                if ($gbn==$gbentry) {
                    $temp=3;
                    push(@delitem, $_); # actually save to a del array
                    }
                else {
                    print FILE $_;
                    }
                }
            else {
                print FILE $_;
            }
        }
        elsif ($temp==3) {
            if (/<!--end-->/) {
                print FILE "<!--end-->\n";
                $temp=5;
            }
            elsif (/^\d+\/\d+\/\d+/) {
                print FILE $_;
                $temp=4;
                }
            else {
                # do nothing (ie. do not write);
                push(@delitem, $_);  # actually save to a del array
            }
        }
        elsif ($temp==4) {
            if (/<!--end-->/) {
                print FILE "<!--end-->\n";
                $temp=5;
            }
            else {
                print FILE $_;
            }
        }
        else {
            print FILE $_;
        }
   }
    close(FILE);
    print "<html><head><title>Update Your Guestbook</title></head>\n";
    print "<body ";
    if ($usemybkgd==1) {
        print "background=\"$mybkgdurl\"&nbsp";
        }
    print "bgcolor=\"#$bkgdc\" TEXT=\"#$textc\" link=\"#$linkc\" vlink=\"#$vlinkc\">\n";
#   print "\n<!--banner code here-->";
    print "<center><img src=\"";
    if ($usemylogo==1) {
        print "$mylogourl";
        }
    else {
        print "$logo";
        }
    print "\"></center>\"";
    print "<h1>Guestbook Item Deleted</h1>\n";
    print "<a href=$baseurl>Return</a>\n";
    print "<br><br><b>The following item has been deleted:</b><hr>\n";
    foreach $item (@delitem) {
        chop($item);
        print "$item";
    }
    print "<hr><h2>Do <font color=\"red\"><b>NOT</b></font> click on your browser Back button!</h2>";
    print "<font size=+1>You must select one of the following:</font>";
    print "<h3>View the new Guestbook</h3>the update guestbook is <a href=$baseurl$pagename.html>here</a>.";
    print " (Remember to press Reload)";
    print "<form action=\"$cgiurl/ezguestd.$cgi\" method=POST>\n";
    print "<p><h3>Update Guestbook</h3></p>\n";
    print "Press this button to continue to delete guestbook entries.\n";
    print "<input type=hidden name=\"userdir\" value=\"$userdir\">\n";
    print "<input type=hidden name=\"pagename\" value=\"$pagename\">\n";
    print "<input type=hidden name=\"action\" value=\"delgbitm\">\n";
    print "<input type=hidden name=\"gbparms\" value=\"$gbparms\">\n";
    print "<input type=hidden name=\"colorset\" value=\"$colorset\">\n";
    print "<P><input type=submit value=\"delete items\">\n";
    print "</form>";
    print "</body></html>";
}

